package org.expeditee.agents;

import java.io.IOException;

import org.expeditee.gui.Frame;
import org.expeditee.gui.MessageBay;
import org.expeditee.io.PdfFramesetWriter;


public class PdfFrameset extends DefaultAgent {
	private PdfFramesetWriter _pdfWriter;
	
	private int _firstFrame = 1;

	private int _maxFrame = Integer.MAX_VALUE;

	public PdfFrameset(int firstFrame, int maxFrame) {
		super();
		_firstFrame = firstFrame;
		_maxFrame = maxFrame;
	}

	public PdfFrameset() {
		super();
		_firstFrame = 1;
		_maxFrame = Integer.MAX_VALUE;
	}

	@Override
	protected Frame process(Frame frame) {
		_pdfWriter = new PdfFramesetWriter(_firstFrame, _maxFrame);
		
		try {
			_pdfWriter.writeFrame(frame);
		} catch (IOException e) {
			MessageBay.errorMessage("PdfFrameset error: " + e.getMessage());
			//e.printStackTrace();
		}
		
		return null;
	}
	
	@Override
	public void stop(){
		_pdfWriter.stop();
	}
}
