package org.expeditee.gui;

import java.awt.Color;
import java.awt.Point;

import org.expeditee.items.Permission;

public class Vector extends Overlay {

	public Point Origin;

	public float Scale;

	public Color Foreground;

	public Color Background;

	public Vector(Frame overlay, Permission permission, Point origin,
			Float scale, Color color, Color background) {
		super(overlay, permission);
		Origin = origin;
		Scale = scale;
		Foreground = color;
		Background = background;
	}

	@Override
	public boolean equals(Object o) {
		if (o == null || o.getClass() != Vector.class)
			return false;
		Vector v = (Vector) o;

		return v.Frame == Frame && Origin.equals(v.Origin)
				&& Scale == v.Scale && Foreground == v.Foreground
				&& Background == v.Background;
	}

	@Override
	public int hashCode() {
		return 0;
	}

	/**
	 * Converts the given x position to be relative to the overlay frame.
	 * 
	 * @param x
	 * @return
	 */
	public float getX(int x) {
		return (x - Origin.x) / Scale;
	}

	public float getY(int y) {
		return (y - Origin.y) / Scale;
	}
}
